> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://contentful.com/developers/docs/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://contentful.com/developers/docs/_mcp/server.

# Delete a role

DELETE https://api.contentful.com/spaces/{space_id}/roles/{role_id}

Use this endpoint to delete an existing role. You can only delete roles if there is no user in the space with *only* that role assigned, i.e. a user must have at least one role.

Reference: https://contentful.com/developers/docs/references/content-management-api/roles/delete-a-role

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `space_id` (string, required) — ID of the space in form of a string
- `role_id` (string, required) — ID of the role in a form of a string

## Response

### 204

No Content - Request successful, no content returned

## Examples

**SDK Code**

```android Android
// Create the Contentful client.
final CMAClient client =
    new CMAClient
        .Builder()
        .setAccessToken("<access_token>")
        .setSpaceId("<space_id>")
        .setEnvironmentId("<environment_id>")
        .build();

client
    .roles()
    .async()
    .fetchOne(
        "<space_id>",
        "<role_id>",
        new CMACallback<CMARole>() {
          @Override protected void onSuccess(CMARole role) {
            // The fetched role will be the parameter of this method.

            // Delete it
            client
                .roles()
                .async()
                .delete(
                    role,
                    new CMACallback<Integer>() {
                      @Override protected void onSuccess(Integer result) {
                        // Updated the role successfully.
                        new AlertDialog.Builder(context)
                            .setTitle("Contentful")
                            .setMessage("Role deleted." +
                                "\n\nResult: " + result)
                            .show();
                      }

                      @Override protected void onFailure(RuntimeException exception) {
                        // An error occurred! Inform the user.
                        new AlertDialog.Builder(context)
                            .setTitle("Contentful Error")
                            .setMessage("Could not delete a role." +
                                "\n\nReason: " + exception.toString())
                            .show();

                        super.onFailure(exception);
                      }
                    }
                );
          }

          @Override protected void onFailure(RuntimeException exception) {
            // An error occurred! Inform the user.
            new AlertDialog.Builder(context)
                .setTitle("Contentful Error")
                .setMessage("Could not get the role." +
                    "\n\nReason: " + exception.toString())
                .show();

            super.onFailure(exception);
          }
        }
    );
```

```java Java
// Create the Contentful client.
final CMAClient client =
    new CMAClient
        .Builder()
        .setAccessToken("<access_token>")
        .setSpaceId("<space_id>")
        .setEnvironmentId("<environment_id>")
        .build();

final CMARole role =
    client
        .roles()
        .fetchOne(
            "<space_id>",
            "<role_id>"
        );

client
    .roles()
    .delete(
        role
    );
```

```kotlin Kotlin
// Create the Contentful client.
val client = CMAClient.Builder()
    .setAccessToken("<access_token>")
    .setSpaceId("<space_id>")
    .setEnvironmentId("<environment_id>")
    .build()

val role = client
        .roles()
        .fetchOne(
                "<space_id>",
                "<role_id>"
        )

client
        .roles()
        .delete(
                role
        )
```

```swift Swift
We currently don't provide a CMA SDK for this platform.
```

```js-legacy JavaScript (legacy)
import { createClient } from 'contentful-management'

const client = createClient({
  accessToken: '<content_management_api_key>'
}, { type: 'legacy' })

client.getSpace('<space_id>')
.then((space) => space.getRole('<role_id>'))
.then((role) => role.delete())
.then(() => console.log('Role deleted.'))
.catch(console.error)
```

```javascript JavaScript
import { createClient } from 'contentful-management'

const client = createClient({
  accessToken: '<content_management_api_key>'
}, { type: 'legacy' })

await client.role.delete({
  spaceId: '<space_id>',
  roleId: '<role_id>',
});
```

```php PHP
$client = new \Contentful\Management\Client('<content_management_api_key>');

$space = $client->getSpaceProxy('<space_id>');

$role = $space->getRole('<role_id>');
$role->delete();
```

```ruby Ruby
require 'contentful/management'

client = Contentful::Management::Client.new('<content_management_api_key>')

role = client.roles('<space_id>').find('<role_id>')
role.destroy
```

```python Python
from contentful_management import Client

client = Client('<content_management_api_key>')

client.roles('<space_id>').delete('<role_id>')

# Alternatively, with an already fetched role:
role = client.roles('<space_id>').find('<role_id>')
role.delete()
```

```.net .NET
// This client should only be created once per application.
var httpClient = new HttpClient();

var client = new ContentfulManagementClient(httpClient, "<content_management_api_key>", "<space_id>");

await client.DeleteRole("<role_id>");
```